/*
	rbf_modulemain.cc

	This file provides the C++ main function which
	creates and runs the following control modules:

		RBF_NN_MODULE

	MODIFICATIONS:
	Wed Dec 20 17:11:24 EST 2000	Created.

*/

// Include Files
#include <stdlib.h>	// exit()
#include <signal.h>	// SIGINT, signal()
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "rbf_nn.hh"	// definition of RBF_NN_MODULE

// flag signifying main loop is to terminate
int rbf_module_done = 0;

//signal handler for ^C
extern "C" void rbf_module_quit(int sig);
void rbf_module_quit(int sig)
{
	rbf_module_done = 1;
}

// main loop, running 1 controller(s)
#ifdef VXWORKS
extern "C" int rbf_module_run();

int rbf_module_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	RCS_TIMER *timer = new RCS_TIMER(0.1);
	RBF_NN_MODULE *rbf_nn = new RBF_NN_MODULE();

	// set the SIGINT handler
	signal(SIGINT, rbf_module_quit);

	// enter main loop
	while(!rbf_module_done)
	{
		rbf_nn->controller();

		timer->wait();
	}

	// Delete Modules
	delete rbf_nn;

	// Delete Timer
	delete timer;
}

