/*
	rbf_modulesvr.cc

	This C++ file provides a main routin to start an NML server for this application
	It connects to all of the NML channels used by this application.
	If they are all valid it will call run_nml_servers(), otherwise it will exit immediately.

	MODIFICATIONS:
	Wed Dec 20 17:11:24 EST 2000	Created.

*/

// Include Files
#include <stdlib.h> // exit()
#include "rcs.hh" 	// Common RCS definitions
#include "rbf_nnn.hh" 	// rbf_nnFormat

// NML Channel Pointers
static RCS_CMD_CHANNEL *rbf_nn_cmd = NULL;
static RCS_STAT_CHANNEL *rbf_nn_stat = NULL;
static NML *errlog = NULL;

static int InitNML()
{


	// rbf_nn
	rbf_nn_cmd = new RCS_CMD_CHANNEL(rbf_nnFormat, "rbf_nn_cmd", "rbf_modulesvr", "rbf_module.nml");
	if(NULL == rbf_nn_cmd)
		return -1;
	if(!rbf_nn_cmd->valid())
		return -1;

	rbf_nn_stat = new RCS_STAT_CHANNEL(rbf_nnFormat, "rbf_nn_sts", "rbf_modulesvr", "rbf_module.nml");
	if(NULL == rbf_nn_stat)
		return -1;
	if(!rbf_nn_stat->valid())
		return -1;

	errlog = new NML(nmlErrorFormat, "errlog", "rbf_modulesvr", "rbf_module.nml");
	if(NULL == errlog)
		return -1;
	if(!errlog->valid())
		return -1;

	return 0;
}

static void DeleteNML()
{

	// rbf_nn
	if(NULL != rbf_nn_cmd)
	{
		delete rbf_nn_cmd;
		rbf_nn_cmd = NULL;
	}

	if(NULL != rbf_nn_stat)
	{
		delete rbf_nn_stat;
		rbf_nn_stat = NULL;
	}

	if(NULL != errlog)
	{
		delete errlog;
		errlog = NULL;
	}

}

// Main 
#ifdef VXWORKS
extern "C" int rbf_modulesvr_run();

int rbf_modulesvr_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	if(InitNML() < 0)
	{
		DeleteNML();
		rcs_exit(-1);
	}

	run_nml_servers();

}

